#include <Windows.h>
#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQuickWindow>
#include <QTimer>

int main(int argc, char *argv[]) {
    QGuiApplication app(argc, argv);
    QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
        &app, [url](QObject *obj, const QUrl &objUrl) {
            if (!obj && url == objUrl)
                QCoreApplication::exit(-1);
        }, Qt::QueuedConnection);
    engine.load(url);
    QQuickWindow *win = qobject_cast<QQuickWindow *> (engine.rootObjects().at(0));
    int x = -500;
    win->setPosition(x, 384);
    QTimer timer;
    timer.setSingleShot(false);
    timer.setInterval(66);
    timer.callOnTimeout([win, &x]() {
            x += 10;
            // using win32 SetWindowPos works
            SetWindowPos((HWND)win->winId(), NULL,
                x, 384, 0, 0,  SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOSIZE | SWP_NOZORDER);
            // using QQuickWindow setPosition there is a jump
//            win->setPosition(x, 384);
        });
    timer.start();
    return app.exec();
}
